
local Gossipmonger_Debug = 1

local panel
local dropdownframe

local CheckBoxes = {
  skipIsDefault = "Gossipmonger_OptionsFrame_SkipIsDefaultCheckBtn",
  informOnSkip_SCT = "Gossipmonger_OptionsFrame_InformOnSkipCheckBtn_SCT",
  informOnSkip_log = "Gossipmonger_OptionsFrame_InformOnSkipCheckBtn_Chat",
  alwaysInformWithName = "Gossipmonger_OptionsFrame_InformOnSkipCheckBtn_NameOnly",
  showGossipMirrorOnSkip = "Gossipmonger_OptionsFrame_ShowBubbleCheckBtn",
  delayShowingMirror = "Gossipmonger_OptionsFrame_ShowBubbleDelayCheckBtn",
};
local CheckBoxIDs = {};

local Gossipmonger_Settings_prev

--[[
local function debugprint(msg)
  if (Gossipmonger_Debug >= 0) then
    DEFAULT_CHAT_FRAME:AddMessage("Gossip: "..msg, 0.494, 0.729, 1);
  end
end
--]]

-- Table Helpers (tcopy and tcount) - by Mikk - from http://www.wowwiki.com/Table_Helpers
-- tcopy: recursively copy contents of one table to another
local function tcopy(to, from)   -- "to" must be a table (possibly empty)
 for k,v in pairs(from) do
   if(type(v)=="table") then
     to[k] = {}
     tcopy(to[k], v);
   else
     to[k] = v;
   end
 end
end


local function UpdateCheckBoxes()
  local box
  for key, val in pairs(CheckBoxes) do
    box = getglobal(val)
    CheckBoxIDs[box:GetID()] = key;
    if (Gossipmonger_Settings[key]) then
      box:SetChecked(1)
    else
      box:SetChecked(0)
    end
  end
end

local function UpdateLabel()
  if (Gossipmonger_Settings.skipIsDefault) then
    dropdownframe:SetLabel(GOSSIPMONGER_STRINGS_MODIFIERKEY_LABEL_DONOT)
  else
    dropdownframe:SetLabel(GOSSIPMONGER_STRINGS_MODIFIERKEY_LABEL_DO)
  end
end

local function CheckBoxChanged(id)
  local key = CheckBoxIDs[id];
  local box = getglobal( CheckBoxes[key] );
  local checked = box:GetChecked();
  if (checked == 1) then
    checked = true;
  else
    checked = false;
  end
  Gossipmonger_Settings[key] = checked;
  if (key == "skipIsDefault") then
    UpdateLabel()
  end
--[[
  local chksay
  if (checked) then  chksay = "true"  else chksay = "false"  end
  debugprint("Gossipmonger_Settings["..key.."] = "..chksay..";")
--]]
end


local KeySelectDropDown = {
  {
    text = GOSSIPMONGER_STRINGS_ALT..GOSSIPMONGER_STRINGS_KEY,
    tooltipTitle = GOSSIPMONGER_STRINGS_ALT..GOSSIPMONGER_STRINGS_KEY,
    tooltipText = GOSSIPMONGER_STRINGS_MODIFIERKEY_TOOLTIP_KEY:format(GOSSIPMONGER_STRINGS_ALT),
    value = 0
  },
  {
    text = GOSSIPMONGER_STRINGS_CTRL..GOSSIPMONGER_STRINGS_KEY,
    tooltipTitle = GOSSIPMONGER_STRINGS_CTRL..GOSSIPMONGER_STRINGS_KEY,
    tooltipText = GOSSIPMONGER_STRINGS_MODIFIERKEY_TOOLTIP_KEY:format(GOSSIPMONGER_STRINGS_CTRL),
    value = 1
  },
  {
    text = GOSSIPMONGER_STRINGS_SHIFT..GOSSIPMONGER_STRINGS_KEY,
    tooltipTitle = GOSSIPMONGER_STRINGS_SHIFT..GOSSIPMONGER_STRINGS_KEY,
    tooltipText = GOSSIPMONGER_STRINGS_MODIFIERKEY_TOOLTIP_KEY:format(GOSSIPMONGER_STRINGS_SHIFT),
    value = 2
  },
  {
    text = GOSSIPMONGER_STRINGS_MODIFIERKEY_NONE,
    tooltipTitle = GOSSIPMONGER_STRINGS_MODIFIERKEY_NONE,
    tooltipText = GOSSIPMONGER_STRINGS_MODIFIERKEY_NONE_TOOLTIP,
    value = 3
  };
};


function Gossipmonger.BuildOptions()
  Gossipmonger_Settings_prev = {};
  tcopy(Gossipmonger_Settings_prev, Gossipmonger_Settings);  -- Remember current settings in case Cancel pressed.

  Gossipmonger_OptionsFrameTitle:SetText( GetAddOnMetadata("Gossipmonger", "Title").." v"..GetAddOnMetadata("Gossipmonger", "Version") )
  if (not SCT) then
    Gossipmonger_OptionsFrame_InformOnSkipCheckBtn_SCT:Disable()
    Gossipmonger_OptionsFrame_InformOnSkipCheckBtn_SCTText:SetText(GOSSIPMONGER_STRINGS_INFORMONSKIP_SCT_DISABLED)
    Gossipmonger_OptionsFrame_InformOnSkipCheckBtn_SCT.tooltip = GOSSIPMONGER_STRINGS_INFORMONSKIP_SCT_DISABLEDTOOLTIP
  end

  dropdownframe = TjDropDownMenu.CreateDropDown(nil, panel, KeySelectDropDown, 0, 0, nil, 5);
  dropdownframe:SetPoint("TOPLEFT", Gossipmonger_OptionsFrame_SkipIsDefaultCheckBtn, "BOTTOMLEFT", -13, -21)
  dropdownframe:SetDropDownWidth(85)
  dropdownframe:OnSelect(function(_, value)
    Gossipmonger_Settings["greetingModifierKey"] = value;
  end)

  panel:SetScript("OnShow", Gossipmonger.OnShowOptions)
  Gossipmonger.OnShowOptions()
end

function Gossipmonger.OnShowOptions()
  UpdateCheckBoxes()
  dropdownframe:SetSelectedValue(Gossipmonger_Settings.greetingModifierKey)
  UpdateLabel()
end

function Gossipmonger.OptionsOkay()
  tcopy(Gossipmonger_Settings_prev, Gossipmonger_Settings);  -- Remember current settings in case Cancel pressed.
end

function Gossipmonger.OptionsCancel()
  tcopy(Gossipmonger_Settings, Gossipmonger_Settings_prev);  -- Revert to previous settings.
end

function Gossipmonger.OptionsDefault()
  Gossipmonger.ResetSettings();
  -- If interface options UI is shown, don't set new (reset) settings as original; user can still hit cancel to
  -- go back to what they were before the reset.
  if (not InterfaceOptionsFrame:IsShown()) then
    tcopy(Gossipmonger_Settings_prev, Gossipmonger_Settings);  -- Remember current settings in case Cancel pressed.
  end
end

function Gossipmonger.OptionsCheckClick(id)
  CheckBoxChanged(id)
end

-- function Gossipmonger.OptionsColorPick(id)
--   debugprint("colorpicker "..id)
-- end

function Gossipmonger.RegisterOptionsPanel(frame)
  panel = frame
  panel:SetScript("OnShow", Gossipmonger.BuildOptions)
  panel.name = GetAddOnMetadata("Gossipmonger", "Title")
  panel.okay = Gossipmonger.OptionsOkay
  panel.cancel = Gossipmonger.OptionsCancel
  panel.default = Gossipmonger.OptionsDefault
  InterfaceOptions_AddCategory(panel);
end

